unit SGridColspanMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, Forms, Controls, Graphics, Dialogs, Grids;

type

  TCalcCellExtent = procedure (Sender: TObject; ACol, ARow: Integer; var aRect: TRect) of object;

  { TStringGrid }

  TStringGrid = class(Grids.TStringGrid)
  private
    fCalcCellExtent: TCalcCellExtent;
  protected
    procedure CalcCellExtent(acol, aRow: Integer; var aRect: TRect); override;
  public
    property OnCalcCellExtent: TCalcCellExtent read fCalcCellExtent write fCalcCellExtent;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Gr1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Gr1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private
    procedure OnCalcCellExtent(Sender: TObject; ACol, ARow: Integer; var aRect: TRect);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  // spaltennummer   -- Inhalt
  cotype = 0;       //was ist das für eine zeile? 1=headtitel 2= headinhalt 4=childtitel 5=childinhalt
  coNdl  = 1 ;      // niederlassung / Name MA bei Child
  coAnzMA= 2;       // mitarbeiteranzahl
  CoAnzAbt= 3;      // Anzahl Abteilungen


{ TStringGrid }

procedure TStringGrid.CalcCellExtent(acol, aRow: Integer; var aRect: TRect);
begin
  inherited CalcCellExtent(acol, aRow, aRect);
  if Assigned(fCalcCellExtent) then
    fCalcCellExtent(self,acol, aRow, aRect);
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var r: integer;
begin
  // Grid mit Datenfüllen
  //1.Abteilungstitel
  r:=0;
  Gr1.Cells[cotype,r]:='1';
  Gr1.Cells[coNdl,r]:='Niederlassung';
  Gr1.Cells[coAnzMA,r]:='Mitarbeiteranzahl';
  Gr1.Cells[CoAnzAbt,r]:='Abteilungsanzahl';
  //1.Abteilung
  r:=1;
  Gr1.Cells[cotype,r]:='2';
  Gr1.Cells[coNdl,r]:='Hamburg';
  Gr1.Cells[coAnzMA,r]:='3';
  Gr1.Cells[CoAnzAbt,r]:='2';
  //1.Childtitel
  r:=2;
  Gr1.Cells[cotype,r]:='4';
  Gr1.Cells[coNdl,r]:='Mitarbeitername';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Abteilung';
  //1.Child
  r:=3;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='HSV';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Fußball';
  //2.Child
  r:=4;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='FC St.Pauli';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Fußball';
  //3.Child
  r:=5;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='SC Rist Wedel';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Basketball';


  //2.Abteilungstitel
  r:=6;
  Gr1.Cells[cotype,r]:='1';
  Gr1.Cells[coNdl,r]:='Niederlassung';
  Gr1.Cells[coAnzMA,r]:='Mitarbeiteranzahl';
  Gr1.Cells[CoAnzAbt,r]:='Abteilungsanzahl';
  //2.Abteilung
  r:=7;
  Gr1.Cells[cotype,r]:='2';
  Gr1.Cells[coNdl,r]:='Berlin';
  Gr1.Cells[coAnzMA,r]:='2';
  Gr1.Cells[CoAnzAbt,r]:='2';
  //2.1.Childtitel
  r:=8;
  Gr1.Cells[cotype,r]:='4';
  Gr1.Cells[coNdl,r]:='Mitarbeitername';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Abteilung';
  //2.1.Child
  r:=9;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='Hertha';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Fußball';
  //2.2.Child
  r:=10;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='Alba';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Basketball';


  //3.Abteilungstitel
  r:=11;
  Gr1.Cells[cotype,r]:='1';
  Gr1.Cells[coNdl,r]:='Niederlassung';
  Gr1.Cells[coAnzMA,r]:='Mitarbeiteranzahl';
  Gr1.Cells[CoAnzAbt,r]:='Abteilungsanzahl';
  //3.Abteilung
  r:=12;
  Gr1.Cells[cotype,r]:='2';
  Gr1.Cells[coNdl,r]:='Bremen';
  Gr1.Cells[coAnzMA,r]:='1';
  Gr1.Cells[CoAnzAbt,r]:='1';
  //3.1.Childtitel
  r:=13;
  Gr1.Cells[cotype,r]:='4';
  Gr1.Cells[coNdl,r]:='Mitarbeitername';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Abteilung';
  //3.1.Child
  r:=14;
  Gr1.Cells[cotype,r]:='5';
  Gr1.Cells[coNdl,r]:='Werder Bremen';
  //Hier nichts: Gr1.Cells[coAnzMA,r]:='';
  Gr1.Cells[CoAnzAbt,r]:='Fußball';

  Gr1.OnCalcCellExtent:=@OnCalcCellExtent;
  Gr1.Options:=Gr1.Options+[goColSpanning];
end;

procedure TForm1.Gr1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
begin
  if Gr1.Cells[cotype,aRow]='1' then begin //Abteilungstitel
    Gr1.Canvas.Font.Style:=Gr1.Canvas.Font.Style+[fsBold];
    Gr1.Canvas.Brush.Color:=clYellow;
  end
  else if (aCol>cotype) and (Gr1.Cells[cotype,aRow]='4') then begin //Childtitel
    Gr1.Canvas.Font.Style:=Gr1.Canvas.Font.Style+[fsBold];
    Gr1.Canvas.Brush.Color:=clMoneyGreen;
  end;
end;

procedure TForm1.OnCalcCellExtent(Sender: TObject; ACol, ARow: Integer;
  var aRect: TRect);
begin
  if (ACol=coNdl)and((Gr1.Cells[cotype,aRow]='4')or(Gr1.Cells[cotype,aRow]='5')) then begin //child und Mitarbeiternamezelle
    aRect.Width:=aRect.Width+Gr1.ColWidths[coAnzMA];
  end
  else if (ACol=coAnzMA)and((Gr1.Cells[cotype,aRow]='4')or(Gr1.Cells[cotype,aRow]='5')) then begin //child und Mitarbeiternamezelle
    aRect.Left:=aRect.Left-Gr1.ColWidths[coNdl];
  end;
end;

end.

